<?php

namespace App\Entity\Abstraction;

use ReflectionClass;
use Symfony\Component\Serializer\Serializer;
use Symfony\Component\Serializer\Encoder\JsonEncoder;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;

class BaseEntity {
    protected array $hidden = [];
    protected array $map = [];
    private array $systemParams = ['hidden', 'map', 'systemParams'];
    public function toArray() {
        $output = [];
        $normalizers = [new ObjectNormalizer()];
        $serializer = new Serializer($normalizers);
        $array = $serializer->normalize($this, null);

        $hidden = array_merge($this->hidden, $this->systemParams);
        foreach ($array as $key => $value) {
            if (in_array($key, $hidden)) {
                continue;
            }
            if (isset($this->map[$key])) {
                $key = $this->map[$key];
            }
            $output[$key] = $value;
        }
        return $output;
    }
}